<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bussinessuserwithdraw_delete"
                   @click="handleDelete">删 除
        </el-button>
        <el-button type="success"
                   size="small"
                   plain
                   icon="el-icon-download"
                   v-if="permission.bussinessuserwithdraw_export"
                   @click="handleExport">导出
        </el-button>
      </template>
      <template slot="menu" slot-scope="{row}">
        <el-button type="text" size="small" icon="el-icon-zoom-in" @click="handleDetail(row)">收款对象</el-button>
      </template>
      <template slot="menuLeft" v-if="data.length > 0">
        <el-button type="warning"
                   size="small"
                   v-if="permission.bussinessuserwithdraw_stat"
                   @click="handleStat">
          代付统计</el-button><span style="color: red; font-weight:bold">{{withdrawStat}}</span>
      </template>
      <template slot="withdrawStatus" slot-scope="{row}">
        <el-tag plain size="small" type="info" v-if="row.withdrawStatus === 10">待发起</el-tag>
        <el-tag plain size="small" type="warning" v-if="row.withdrawStatus === 11">请求已接收(处理中)</el-tag>
        <el-tag plain size="small" type="warning" v-if="row.withdrawStatus === 12">请求已受理(处理中)</el-tag>
        <el-tag plain size="small" type="warning" v-if="row.withdrawStatus === 13">银行处理中(处理中)</el-tag>
        <el-tag plain size="small" type="danger" v-if="row.withdrawStatus === 14">失败</el-tag>
        <el-tag plain size="small" type="success" v-if="row.withdrawStatus === 15">成功</el-tag>
      </template>
    </avue-crud>
    <el-dialog :modal-append-to-body="false" :visible.sync="withdrawDetailVisible" title="收款对象" width="40%">
      <div>
        <span style="margin:10px;">
          <font size="3">收款账户名：</font>
        </span>
        <span style="margin:10px;">
          {{withdrawObject.receiverAccountName}}
        </span>
      </div>
      <div>
        <span style="margin:10px;">
          <font size="3">
            银行卡编码：
          </font>
        </span>
        <span style="margin:10px;">
          {{withdrawObject.bankCode}}
        </span>
      </div>
      <div>
        <span style="margin:10px;">
          <font size="3">
            账户类型：
          </font>
        </span>
        <span>
          {{withdrawObject.receiveType}}
        </span>
      </div>
      <div>
        <span style="margin:10px;">
          <font size="3">
            银行卡号：
          </font>
        </span>
        <span>
          {{withdrawObject.bankAccountNo}}
        </span>
      </div>
      <div>
        <span style="margin:10px;">
          <font size="3">
            收款金额：
          </font>
        </span>
        <span>
          {{withdrawObject.orderAmount}}
        </span>
      </div>
      <div>
        <span style="margin:10px;">
          <font size="3">
            收款状态：
          </font>
        </span>
        <span>
          {{withdrawObject.$withdrawStatus}}
        </span>
      </div>
    </el-dialog>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, withdrawStat} from "@/api/bussinessmng/bussinessuserwithdraw";
  import {mapGetters} from "vuex";
  import website from '@/config/website';
  import {getToken} from '@/util/auth';

  export default {
    props:{
      userInfoId: null
    },
    data() {
      return {
        form: {},
        search:{},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        withdrawStat:"",
        withdrawObject:{},
        withdrawDetailVisible: false,
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          editDisplay: false,
          addDisplay: false,
          delBtn: false,
          menu: true,
          dialogClickModal: false,
          column: [
            {
              label: "采购商",
              prop: "bussinessId",
              type: "select",
              search: true,
              filterable: true,
              searchSpan: 4,
              dicUrl: "/api/cyzh-guosen/bussiness/listBussiness?size=500",
              props:{
                label: "name",
                value: "id"
              },
            },
            {
              label: "账号",
              prop: "bankAccountNo",
              hide: true
            },
            {
              label: "到账类型",
              prop: "receiveType",
              type: "select",
              hide: true,
              dicData: [
                {
                  label: '实时',
                  value: "REAL_TIME"
                },
                {
                  label: '2小时到账',
                  value: "TWO_HOUR"
                },
                {
                  label: '次日到账',
                  value: "NEXT_DAY"
                }
              ]
            },
            {
              label: "收款金额（元）",
              prop: "orderAmount",
            },
            {
              label: "收款账户名",
              prop: "userInfoId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bussiness-user-info/bussinessuserinfo/listUserInfo",
              props:{
                label: "userName",
                value: "id"
              },
            },
            {
              label: "收款状态",
              prop: "withdrawStatus",
              type: "select",
              search: true,
              searchSpan: 4,
              slot:true,
              dicData: [
                {
                  label: '待发起',
                  value: 10
                },
                {
                  label: '请求已接收(处理中)',
                  value: 11
                },
                {
                  label: '请求已受理(处理中)',
                  value: 12
                },
                {
                  label: '银行处理中(处理中)',
                  value: 13
                },
                {
                  label: '失败',
                  value: 14
                },
                {
                  label: '成功',
                  value: 15
                },
              ]
            },
            {
              label: "是否冲退",
              prop: "isReversed",
              dicData: [
                {
                  label: '是',
                  value: 1
                },
                {
                  label: '否',
                  value: 0
                },
              ]
            },
            {
              label: "失败原因",
              prop: "failReason",
            },
            {
              label: "采购商订单号",
              prop: "bussinessOrderId",
              searchLabelWidth: 110,
              search:true
            },
            {
              label: "时间",
              prop: "createTime",
              type: "date",
              search: true,
              valueFormat: "yyyy-MM-dd HH:mm:ss",
              searchSpan: 4,
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussinessuserwithdraw_add, false),
          viewBtn: this.vaildData(this.permission.bussinessuserwithdraw_view, false),
          delBtn: this.vaildData(this.permission.bussinessuserwithdraw_delete, false),
          editBtn: this.vaildData(this.permission.bussinessuserwithdraw_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      handleExport(){
        this.$confirm("是否导出数据?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          let createTimeStr = "";
          let withdrawStatus = "";
          if(this.query.createTime){
            createTimeStr = this.query.createTime;
          }
          if(this.query.withdrawStatus){
            withdrawStatus = this.query.withdrawStatus;
          }
          window.open(`/api/cyzh-bussiness-user-withdraw/bussinessuserwithdraw/export-withdraw?${this.website.tokenHeader}=${getToken()}&createTimeStr=${createTimeStr}&withdrawStatus=${withdrawStatus}`);
        });
      },
      handleDetail(row){
        this.withdrawDetailVisible = true;
        this.withdrawObject = row;
      },
      handleStat(){
        withdrawStat(this.query).then(res =>{
          this.withdrawStat = "¥" + res.data.data;
        })
      },
      searchReset() {
        this.debtStat = "";
        this.query = {};
        this.onLoad(this.page);
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
                .then(() => {
                  return remove(row.id);
                })
                .then(() => {
                  this.onLoad(this.page);
                  this.$message({
                    type: "success",
                    message: "操作成功!"
                  });
                });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
                .then(() => {
                  return remove(this.ids);
                })
                .then(() => {
                  this.onLoad(this.page);
                  this.$message({
                    type: "success",
                    message: "操作成功!"
                  });
                  this.$refs.crud.toggleSelection();
                });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.withdrawStat = "";
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        if(this.userInfoId != null){
          params['userInfoId'] = this.userInfoId;
        }
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
